module AdvancedDCL
  module Common
    def param_init
      @param = Parameter.new
      @param.init("uref", Float, "uurset", "uurget", 0, 0)
      @param.init("tpat", [Fixnum, 2], "uusarp", "uuqarp", 2, 2)
      @param.init("rundef", Float, "glrset", "glrget", 0, 0)
      @param.init("iundef", Fixnum, "glrset", "glrget", 0, 0)

      @param.init("arrowtype", Fixnum, "sgslat", "sgqlat", 1, 1)
      @param.init("arrowindex", Fixnum, "sgslai", "sgqlai", 1, 1)
      
      @param.init("frtype", Fixnum, "uusfrt", "uuqfrt", 1, 1)
      @param.init("frindex", Fixnum, "uusfri", "uuqfri", 1, 1)
      @param.init("barwidth", Float, "uusbrs", "uuqbrs", 1, 1)
      @param.init("lineindex", Fixnum, "lineindex", "uuqlni", 3, 1)
      @param.init("linetype", Fixnum, "linetype", "uuqlnt", 3, 1)
      @param.init("variablerange", [2, Float], "variablerange", "variabelrangeget", 3, 3)

      @param.init("indexmj", Fixnum, "indexmj", "indexmjget", 3, 2)
      @param.init("indexmn", Fixnum, "indexmn", "indexmnget", 3, 2)

      @temp_param = @param.dup
      @backup = @param.dup
    end

    private :param_init
    
    def param
      @param
    end
    
    module_function :param_init
    module_function :param
    
    param_init
  end
end
