module AdvancedDCL
  module Mark
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("pmfact", Float, "sgrset", "sgrget", 0, 0)
      @param.init("npmskip", Float, "sgrset", "sgrget", 0, 0)
      
      @param.init("marktype", Fixnum, "marktype", "uuqmkt", 3, 1)
      @param.init("markindex", Fixnum, "markindex", "uuqmki", 3, 1)
      @param.init("marksize", Float, "marksize", "uuqmks", 3, 1)
      
      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def draw(x, y, temp=nil)
      rundef = Fig.rundef
      Basics.checkundef(x, y)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf
      if(x==rundef)
	DCL.uumrk(y.length, x, y)
      elsif(y==rundef)
	DCL.uumrk(x.length, x, y)
      else
	DCL.uumrk(x.length, x, y)
      end

      @backup.sync
      @temp_param.clear
    end

    def vdraw(x, y, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      #Fig.settrf

      DCL.sgpmu(x.length, x, y)
      
      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :draw
    module_function :vdraw

    param_init

#----------------------------------------------------------
    def @param.markindex(index)
      DCL.uusmki(index)
      DCL.sgspmi(index)
    end

    def @temp_param.markindex(index)
      DCL.uusmki(index)
      DCL.sgspmi(index)
    end

    def @backup.markindex(index)
      DCL.uusmki(index)
      DCL.sgspmi(index)
    end

    def @param.marktype(type)
      DCL.uusmkt(type)
      DCL.sgspmt(type)
    end

    def @temp_param.marktype(type)
      DCL.uusmkt(type)
      DCL.sgspmt(type)
    end

    def @backup.marktype(type)
      DCL.uusmkt(type)
      DCL.sgspmt(type)
    end

    def @param.marksize(size)
      DCL.uusmks(size)
      DCL.sgspms(size)
    end

    def @temp_param.marksize(size)
      DCL.uusmks(size)
      DCL.sgspms(size)
    end

    def @backup.marksize(size)
      DCL.uusmks(size)
      DCL.sgspms(size)
    end

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
