module AdvancedDCL
  module Vector
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("lineindex", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("icent", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("itype1", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("itype2", Fixnum, "uglset", "uglget", 0, 0)
      @param.init("iuindx", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("iunttl", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("iutxro", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("iutyro", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("ixint", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("iyint", Fixnum, "ugiset", "ugiget", 0, 0)
      @param.init("leqrat", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lmissp", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lmsg", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lnrmal", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lsmall", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lumsg", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("lunit", TrueClass, "uglset", "uglget", 0, 0)
      @param.init("rhfact", Float, "ugrset", "ugrget", 0, 0)
      @param.init("rsizem", Float, "ugrset", "ugrget", 0, 0)
      @param.init("rsizet", Float, "ugrset", "ugrget", 0, 0)
      @param.init("rsizeut", Float, "ugrset", "ugrget", 0, 0)
      @param.init("rsmall", Float, "ugrset", "ugrget", 0, 0)
      @param.init("rundef", Float, "ugrset", "ugrget", 0, 0)
      @param.init("uxunit", Float, "ugrset", "ugrget", 0, 0)
      @param.init("uyunit", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vutoff", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vxuloc", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vxunit", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vxuoff", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vyuloc", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vyunit", Float, "ugrset", "ugrget", 0, 0)
      @param.init("vyuoff", Float, "ugrset", "ugrget", 0, 0)
      @param.init("xfact1", Float, "ugrset", "ugrget", 0, 0)
      @param.init("xfact2", Float, "ugrset", "ugrget", 0, 0)
      @param.init("xttl", Float, "ugrset", "ugrget", 0, 0)
      @param.init("yfact1", Float, "ugrset", "ugrget", 0, 0)
      @param.init("yfact2", Float, "ugrset", "ugrget", 0, 0)
      
      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

    def uvtitle(cside, cttl)
      DCL.ugsut(cside, cttl)
    end
#----------------------------------------------------------
#------------ draw method ----------------------
    
    def draw(u, v, x=nil, y=nil, temp=nil)
      if(!(y.is_a?(Hash)))
	if(x.is_a?(Hash))
	  temp = x.dup
	  x = nil
	elsif(Basics.typearray(x))
	  if(!Basics.typearray(y))
	    raise ArgumentError, "both x & y must be Array or NArray(or nil)"
	  end
	end
      else
	raise ArgumentError, "both x & y must be Array or NArray(or nil)"
      end

      ux = u.shape[0]
      uy = u.shape[1]
      vx = v.shape[0]
      vy = v.shape[1]

      if(uy != vy)
	raise ArgumentError, "shape of vector components(u & v) are mismutch"
      end
      
      if(ux >= vx)
	nx = ux
      else
	nx = vx
      end

      if(Basics.typearray(x) && Basics.typearray(y))
	DCL.uwsgxa(x, x.length)
	DCL.uwsgya(y, y.length)
	Basics.checkundef(x, y)
      else
	Basics.checkundef(nx.to_f, uy.to_f)
      end

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf
    
      DCL.ugvect(u, ux, v, vx, nx, uy)
      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :uvtitle
    module_function :draw

    param_init

#----------------------------------------------------------

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
